// import {safeDispatch, port} from './port'
import $$observable from 'symbol-observable';
import { nextEventID, toTag, counter } from './id'; // import type {Event, Effect} from './index.h'

export function basicCommon(domainName, name) {
  var type = toTag(domainName, name);
  return {
    eventID: nextEventID(),
    nextSeq: counter(),
    getType: () => type
  };
}
export function observable(event, action$) {
  function observableState() {
    return {
      /**
       * The minimal observable subscription method.
       * @param {Object} observer Any object that can be used as an observer.
       * The observer object should have a `next` method.
       * @returns {subscription} An object with an `unsubscribe` method that can
       * be used to unsubscribe the observable from the store, and prevent further
       * emission of values from the observable.
       */
      subscribe(observer) {
        if (typeof observer !== 'object') {
          throw new TypeError('Expected the observer to be an object.');
        }

        return action$.subscribe(observer);
      },

      [O]() {
        return event;
      }

    };
  }

  var O = $$observable;
  event[O] = observableState;
}
//# sourceMappingURL=event-common.js.map