import { PING, PONG, HALT } from './config';
export function effectorMiddleware() {
  var plainMap = new Map();
  var config = {
    plain: plainMap
  };
  var isActive = true;
  return next => action => {
    if (!isActive) {
      return action;
    }

    if (!(typeof action === 'object' && action != null)) {
      return next(action);
    }

    if (typeof action.type !== 'string') {
      return action;
    }

    if (action.type === PING) {
      return {
        type: PONG,
        payload: config
      };
    }

    if (action.type === HALT) {
      isActive = false;
      plainMap.clear();
      return next(action);
    }

    var handler = plainMap.get(action.type);
    if (!(typeof action.meta === 'object' && action.meta != null)) action.meta = {};
    if (action.meta.passed === true) return action;
    if (handler) action.meta.plain = true;

    if (typeof action.send === 'function') {
      var {
        send,
        meta
      } = action;

      if (handler) {
        meta.passed = true;
        send(next);
        handler(action);
        return action;
      }

      action.send(next);
      return action;
    } else {
      var {
        meta: _meta
      } = action;

      if (handler) {
        if (_meta.passed !== true) {
          _meta.passed = true;
          var result = next(action);
          handler(action);
          return result;
        }

        action.meta.passed = true;
      }

      action.meta.passed = true;
      return next(action);
    }
  };
}
//# sourceMappingURL=middleware.js.map