function isAction(data) {
  return typeof data === 'object' && data != null && typeof data.type === 'string';
}

export function safeDispatch(data, dispatch) {
  if (Array.isArray(data)) {
    data.filter(isAction).forEach(action => dispatch(action));
  } else if (isAction(data)) dispatch(data);

  return data;
}
export function port(dispatch, state$, action$) {
  return function epic(handler) {
    var result = handler(action$, state$).multicast();
    result.observe(data => safeDispatch(data, dispatch));
    return result;
  };
}
//# sourceMappingURL=port.js.map