"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createWatcher = createWatcher;

var _most = require("most");

var _subject = require("../subject");

var _warn = require("./warn");

function createWatcher({
  event,
  domainName,
  name,
  opts
}) {
  return function watch(fn) {
    event.epic((data$, state$) => (0, _most.combine)((data, state) => ({
      data,
      state
    }), data$, state$).sampleWith(data$).map(({
      data,
      state
    }) => {
      try {
        var result = fn(data, state);
        return result;
      } catch (err) {
        watchFailWarn({
          domainName,
          name,
          mode: opts.watchFailCheck()
        }, err);
      }
    }));
  };
}

function watchFailWarn({
  domainName,
  name,
  mode
}, error) {
  switch (mode) {
    case 'throw':
      {
        throw error;
      }

    case 'warn':
      {
        (0, _warn.watchWarn)(domainName, name, error);
      }

    case 'off':
    default:
      {
        return;
      }
  }
}
//# sourceMappingURL=watch.js.map