"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.basicCommon = basicCommon;
exports.observable = observable;

var _symbolObservable = _interopRequireDefault(require("symbol-observable"));

var _id = require("./id");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// import {safeDispatch, port} from './port'
// import type {Event, Effect} from './index.h'
function basicCommon(domainName, name) {
  var type = (0, _id.toTag)(domainName, name);
  return {
    eventID: (0, _id.nextEventID)(),
    nextSeq: (0, _id.counter)(),
    getType: () => type
  };
}

function observable(event, action$) {
  function observableState() {
    return {
      /**
       * The minimal observable subscription method.
       * @param {Object} observer Any object that can be used as an observer.
       * The observer object should have a `next` method.
       * @returns {subscription} An object with an `unsubscribe` method that can
       * be used to unsubscribe the observable from the store, and prevent further
       * emission of values from the observable.
       */
      subscribe(observer) {
        if (typeof observer !== 'object') {
          throw new TypeError('Expected the observer to be an object.');
        }

        return action$.subscribe(observer);
      },

      [O]() {
        return event;
      }

    };
  }

  var O = _symbolObservable.default;
  event[O] = observableState;
}
//# sourceMappingURL=event-common.js.map