"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.mill = mill;
exports.Mill = void 0;

var _reducer = require("./reducer");

var _joint = require("./joint");

class Mill {
  and(red) {
    return new Mill([...this.parts, red]);
  }

  joint(fn) {
    var reducers = this.parts.length === 0 ? [(0, _reducer.createReducer)()] : this.parts;
    var join = _joint.joint;
    var joined = join(fn, ...reducers);
    return joined;
  }

  constructor(parts = []) {
    this.parts = parts;
  }

}

exports.Mill = Mill;

function mill() {
  return new Mill();
}
//# sourceMappingURL=mill.js.map